Index: trunk/LMDZ.TITAN/libf/phytitan/evapCH4.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/evapCH4.F90	(revision 3083)
+++ trunk/LMDZ.TITAN/libf/phytitan/evapCH4.F90	(revision 3083)
@@ -0,0 +1,230 @@
+subroutine evapCH4(ngrid,nlayer,ptimestep,pplev,zzlay,zzlev, &
+                   u,v,tsurf,pqCH4, &
+                   tankCH4,pdqCH4,dtsurfevap)
+
+use radcommon_h, only: gzlat         ! Gravity of the planet [m.s-2]
+use planete_mod, only: z0            ! Surface roughness of the planet [m]
+use geometry_mod, only: latitude_deg ! Latitude grid of the planet [°]
+
+implicit none
+
+!====================================================================
+!
+!   Purpose
+!   -------
+!   Surface flux for methane evaporation.
+!   The routine calculates the surface flux of methane
+!   And the latente heat of methane evaporation.
+!
+!   Implicit scheme.
+!   We start by adding to variables x the physical tendencies already computed.
+!   We resolve the equation :
+!   x(t+1) =  x(t) + A * (dx/dt) * dt
+!
+!
+!   INPUT
+!   -----
+!   ngrid     = Number of grid points in the chunk [-]
+!   nlayer    = Number of vertical layers [-]
+!   ptimestep = Time step [s]
+!   pplev     = Intermediate pressure levels [Pa]
+!   zzlay     = Altitude at the middle of the atmospheric layers (ref : local surf) [m]
+!   zzlev     = Altitude at the atmospheric layer boundaries (ref : local surf) [m]
+!   u         = Zonal component of the wind [m.s-1]
+!   v         = Meridional component of the wind [m.s-1]
+!   tsurf     = Surface temperature [K]
+!   pqCH4     = Molar fraction of CH4 [mol.mol-1]
+!
+!
+!   OUTPUT
+!   ------
+!   tankCH4    = Depth of surface methane tank [m]
+!   pdqCH4     = Molar fraction tendency of CH4 at the surface [mol.mol-1.s-1]
+!   dtsurfevap = Evaporation heating rate at the surface [K.s-1]
+!
+!
+!   Author(s)
+!   ---------
+!   B. de Batz de Trenquelléon (10/2022)
+!
+!====================================================================    
+
+
+!------------------------------------
+! 0. DECLARATIONS
+!------------------------------------
+
+! Inputs :
+!---------
+integer, intent(in) :: ngrid
+integer, intent(in) :: nlayer
+real, intent(in)    :: ptimestep
+real, intent(in)    :: pplev(ngrid,nlayer+1)
+real, intent(in)    :: zzlay(ngrid,nlayer)
+real, intent(in)    :: zzlev(ngrid,nlayer+1)
+real, intent(in)    :: u(ngrid,nlayer)
+real, intent(in)    :: v(ngrid,nlayer)
+real, intent(in)    :: tsurf(ngrid)
+real, intent(in)    :: pqCH4(ngrid,nlayer)
+
+! Outputs :
+!----------
+real, intent(out) :: tankCH4(ngrid)
+real, intent(out) :: pdqCH4(ngrid)
+real, intent(out) :: dtsurfevap(ngrid)
+
+! Parameters :
+!-------------
+real, parameter :: karman = 0.4     ! Karman constant [-]
+real, parameter :: humCH4 = 0.5     ! Imposed surface humidity for CH4 [-]
+
+real, parameter :: Flnp = 0.01      ! Fraction occupied by lakes (North Pole)
+real, parameter :: Flsp = 0.005     ! Fraction occupied by lakes (South Pole)
+
+real, parameter :: mmolair = 28.e-3 ! Molar mass of air [kg.mol-1]
+real, parameter :: mmolCH4 = 16.e-3 ! Molar mass of CH4 [kg.mol-1]
+real, parameter :: rhoiCH4 = 425.   ! Density of ice of CH4 [kg.m-3]
+
+real, parameter :: TcCH4  = 190.56  ! Critical point of CH4 [K]
+real, parameter :: Cplake = 2689992 ! Surface heat capacity for hydrocarbon lakes [J.m-2.K-1] (Tokano 2005)
+
+! Local variables :
+!------------------
+integer :: ig
+
+! Initialisation :
+real*8  :: rhoair     ! Density of air [kg.m-3]
+real*8  :: ws         ! Horizontal wind at the surface [m.s-1]
+real*8  :: Cd         ! Turbulent term [-]
+real*8  :: qsatCH4    ! Saturation profile of CH4 [mol.mol-1]
+
+! Flux :
+real*8  :: flux       ! Surface flux [kg.m-2.s-1]
+real*8  :: fluxCH4    ! Surface flux fo CH4 [kg.m-2.s-1.mol.mol-1]
+
+! Variations of CH4 :
+real*8  :: newpqCH4   ! New molar fraction of CH4 in the first layer [mol.mol-1]
+real*8  :: dtankCH4   ! Trend of CH4's tank [m]
+
+! Latente heat :
+real*8  :: ftm, LvCH4 ! Variables for latente heat [-, J.kg-1]
+
+
+!------------------------------------
+! 1. INITIALISATION
+!------------------------------------
+
+do ig = 1, ngrid ! Main loop on the horizontal grid
+
+  ! Density of the first layer of the atmosphere [kg.m-3]
+  rhoair = (pplev(ig,1) - pplev(ig,2)) / gzlat(ig,1) / (zzlev(ig,2) - zzlev(ig,1))
+
+  ! Horizontal winds at the surface [m.s-1]
+  ws = sqrt(u(ig,1)*u(ig,1) + v(ig,1)*v(ig,1)) * (10. / zzlay(ig,1))**0.2
+
+  ! Source of turbulent kinetic energy at the surface [-] (Forget et al. 1999)
+  Cd = (karman / log(1. + zzlay(ig,1)/z0))**2
+
+  ! Saturation profile of CH4 [mol.mol-1] (Fray and Schmidt 2009) :
+  qsatCH4 = (1.0e5 / pplev(ig,1)) * exp(1.051e1 - 1.110e3/tsurf(ig) - 4.341e3/tsurf(ig)**2 + 1.035e5/tsurf(ig)**3 - 7.910e5/tsurf(ig)**4)
+  qsatCH4 = humCH4 * qsatCH4
+  ! CH4 : 0.85 * qsat because of dissolution in N2
+  qsatCH4 = 0.85 * qsatCH4
+
+  ! Flux at the surface [kg.m-2.s-1] :
+  flux = rhoair * Cd * ws
+
+  ! <North Pole>
+  if (REAL(latitude_deg(ig)) .ge. 70.) then
+    flux = Flnp * flux
+  ! <South Pole>
+  else if (REAL(latitude_deg(ig)) .le. -70.) then
+    flux = Flsp * flux
+  ! <Mid Latitudes>
+  else
+    flux = 0.0
+  endif
+
+  ! Empty tank ?
+  if (tankCH4(ig) .le. 1.e-30) then
+    flux = 0.0
+    tankCH4(ig) = 1.e-30
+  endif
+  
+  ! Flux of CH4 at the surface [kg.m-2.s-1.mol.mol-1] :
+  fluxCH4 = flux * (qsatCH4 - pqCH4(ig,1))
+
+
+!------------------------------------
+! 2. IMPLICIT SCHEME
+!------------------------------------
+
+  ! Flux at the surface [kg.m-2.s-1] --> [s-1] :
+  flux = flux / rhoair / (zzlev(ig,2) - zzlev(ig,1))
+
+  ! New molar fraction of CH4 in the first layer [mol.mol-1] : 
+  newpqCH4 = (pqCH4(ig,1) + flux * ptimestep * qsatCH4) / (1. + flux * ptimestep)
+
+  ! Trend of CH4's tank [m]
+  dtankCH4 = - (newpqCH4 - pqCH4(ig,1)) * rhoair * (zzlev(ig,2) - zzlev(ig,1)) * mmolCH4 / mmolair / rhoiCH4
+
+  ! New tank depth of CH4 [m]
+  if ((tankCH4(ig) + dtankCH4) .ge. 0.) then
+    tankCH4(ig) = tankCH4(ig) + dtankCH4
+  else
+    newpqCH4 = tankCH4(ig) / (rhoair * (zzlev(ig,2) - zzlev(ig,1)) * mmolCH4 / mmolair / rhoiCH4) + pqCH4(ig,1)
+    tankCH4(ig) = 1.e-30
+  endif
+
+  ! Trend of CH4's molar fraction in the first layer [mol.mol-1.s-1]
+  pdqCH4(ig) = (newpqCH4 - pqCH4(ig,1)) / ptimestep
+
+
+!------------------------------------
+! 3. LATENTE HEAT
+!------------------------------------
+
+  ftm = (1. - tsurf(ig) / TcCH4)
+  if(ftm .le. 1.e-3) then
+    ftm = 1.e-3
+  endif
+  
+  ! Latente heat of CH4 vaporisation [J.kg-1.mol.mol-1]
+  LvCH4 = 8.314 * 190.4 * (7.08 * ftm**0.354 + 10.95 * 1.1e-2 * ftm**0.456) / mmolCH4
+
+  ! Evaporation heating rate [K.s-1]
+  dtsurfevap(ig) = - (fluxCH4 * LvCH4) / Cplake
+
+  ! >>> [TEMPO : BBT]
+  !open(501,file='Evap_CH4.out')
+  !if(REAL(latitude_deg(ig)) .ge. 70.) then
+  !      write(501,*) '-----------------------------------'
+  !      write(501,*) 'Latitude =', REAL(latitude_deg(ig))
+  !      write(501,*) ''
+  !      write(501,*) 'Initialisation variables :'
+  !     write(501,*) 'Air density =', rhoair, 'kg.m-3'
+  !      write(501,*) 'Horizontal wind =', ws, 'm.s-1'
+  !      write(501,*) 'Turbulent term =', Cd
+  !      write(501,*) 'CH4 saturation at the surface =', qsatCH4, 'mol.mol-1'
+  !      write(501,*) ''
+  !      write(501,*) 'Flux :'
+  !      write(501,*) 'Flux of CH4 =', fluxCH4, 'kg.m-2.s-1.mol.mol-1'
+  !      write(501,*) ''
+  !      write(501,*) 'Variation of CH4 :'
+  !      write(501,*) 'New molar fraction of CH4 =', newpqCH4, 'mol.mol-1'
+  !      write(501,*) 'Trend of CH4 =', pdqCH4(ig), 'mol.mol-1.s-1'
+  !      write(501,*) 'Variation of CH4 tank =', dtankCH4, 'm'
+  !      write(501,*) ''
+  !      write(501,*) 'Latent Heat :'
+  !      write(501,*) 'Latente heat of CH4 vaporisation =', LvCH4, 'J.kg-1.mol.mol-1.s-1'
+  !      write(501,*) 'dtsurfevap :', dtsurfevap(ig), 'K.s-1'
+  !      write(501,*) '-----------------------------------'
+  !endif
+  !close(501)
+  ! <<< [TEMPO : BBT]
+
+enddo ! End of main loop on the horizontal grid
+
+return
+
+end subroutine evapCH4
Index: trunk/LMDZ.TITAN/libf/phytitan/get_haze_and_cloud_opacity.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/get_haze_and_cloud_opacity.F90	(revision 3083)
+++ trunk/LMDZ.TITAN/libf/phytitan/get_haze_and_cloud_opacity.F90	(revision 3083)
@@ -0,0 +1,328 @@
+subroutine get_haze_and_cloud_opacity(FTYPE,CTYPE,m0,m3,ich,tauext,wbar,gbar)
+
+  use datafile_mod, only : datadir
+  use radinc_h, only : L_NSPECTI, L_NSPECTV
+
+  implicit none
+
+  !============================================================================
+  !
+  !     Purpose
+  !     -------
+  !     Calculates the opacity of a GCM cell from the m0, m3
+  !     and particle type information.
+  !
+  !
+  !     INPUT: 
+  !     ------
+  !     FTYPE : which fractal particle type will be used in the GCM.
+  !             This is used at the first call, and defined once for all.
+  !             FTYPE = 1 : Df = 2.00
+  !             FTYPE = 2 : Df = 2.15
+  !             FTYPE = 3 : Df = 2.30
+  !             FTYPE = 4 : Df = 2.45
+  !
+  !     CTYPE : which particle type is currently called.
+  !             CTYPE = 0 : CLOUD DROPLETS
+  !             CTYPE = 1 : FRACTAL AEROSOLS (Df = 2.00)
+  !             CTYPE = 2 : FRACTAL AEROSOLS (Df = 2.15)
+  !             CTYPE = 3 : FRACTAL AEROSOLS (Df = 2.30)
+  !             CTYPE = 4 : FRACTAL AEROSOLS (Df = 2.45)
+  !             CTYPE = 5 : SPHERICAL AEROSOLS (MODE OF SMALL AEROSOLS)
+  !
+  !     m0  = 0th order moment of particule.
+  !     m3  = 3rd order moment of particule.
+  !     ich = spectral channel [1,...,46].
+  !
+  !
+  !     OUPUT:
+  !     ------
+  !     tauext = opacity.
+  !     wbar   = average single scattering albedo.
+  !     gbar   = average asymmetry parameter.
+  !
+  !
+  !     Authors
+  !     -------
+  !     B. de Batz de Trenquelleon (08/2022).
+  !
+  !============================================================================
+
+
+  !-------------------------
+  ! 0. Declarations
+  !-------------------------
+
+  ! INPUTS :
+  !---------
+  integer,intent(in) :: FTYPE
+  integer,intent(in) :: CTYPE
+
+  real*8,intent(in) :: m0
+  real*8,intent(in) :: m3
+
+  integer,intent(in) :: ich
+
+  ! OUTPUTS :
+  !----------
+  real*8,intent(out) :: tauext
+  real*8,intent(out) :: wbar
+  real*8,intent(out) :: gbar
+  
+  ! PARAMETERS :
+  !-------------
+  integer :: nwl
+  integer :: nrad
+  integer :: ii,iii,kk,kkk
+
+  parameter(nwl = L_NSPECTI + L_NSPECTV, nrad = 33)
+
+  real*8 :: xwlnv(nwl)
+  
+  ! Spherical aerosols :
+  real*8, save :: rc_as(nrad)
+  real*8, save :: ssca_as(nwl,nrad),sabs_as(nwl,nrad),sext_as(nwl,nrad)
+  real*8, save :: wbar_as(nwl,nrad),gbar_as(nwl,nrad)
+  ! Fractal aerosols :
+  real*8, save :: rc_f(nrad)
+  real*8, save :: ssca_f(nwl,nrad),sabs_f(nwl,nrad),sext_f(nwl,nrad)
+  real*8, save :: wbar_f(nwl,nrad),gbar_f(nwl,nrad)
+  ! Cloud droplets :
+  real*8, save :: rc_s(nrad)
+  real*8, save :: ssca_s(nwl,nrad),sabs_s(nwl,nrad),sext_s(nwl,nrad)
+  real*8, save :: wbar_s(nwl,nrad),gbar_s(nwl,nrad)
+  
+  ! LOCAL VARIABLES FOR INTERPOLATION :
+  !------------------------------------
+  integer :: idx
+  real*8  :: rinit,rc,step,xfact
+  character(len=100) :: aer_sph_file,aer_fra_file,cloud_file
+  logical            :: file_ok
+  logical,save       :: firstcall = .true.
+
+  ! INITIALISATION :
+  !-----------------
+  tauext = 0.0
+  wbar   = 0.0
+  gbar   = 0.0
+
+  !---------------------------------------------------
+  ! 1. First call : open and read the first time
+  !---------------------------------------------------
+  
+  ! Check spectral channel :
+  if(ich.lt.1 .or. ich.gt.nwl) then
+    print*, "ERROR : ich.lt.1 .or. ich.gt.nwl in get_haze_and_cloud_opacity"
+    call abort
+  endif
+
+  if(firstcall) then
+
+    ! Spherical aerosols :
+    aer_sph_file = trim(datadir)//'/optical_tables/table_sigma_int2_sph3.00_rm50nm.dat'
+    inquire(file=trim(aer_sph_file),exist=file_ok)
+    if(.not.file_ok) then
+      write(*,*) 'The file ',TRIM(aer_sph_file),' was not found by get_haze_and_cloud_opacity.F90 !'
+      write(*,*) 'Check in ', TRIM(datadir),' that you have the one corresponding !!'
+      call abort
+    endif
+    open(unit = 27, file = aer_sph_file)
+    
+    ! Fractal aerosols :
+    if(FTYPE.eq.1) aer_fra_file = trim(datadir)//'/optical_tables/table_sigma_int2_fr2.00_rm50nm.dat'
+    if(FTYPE.eq.2) aer_fra_file = trim(datadir)//'/optical_tables/table_sigma_int2_fr2.15_rm50nm.dat'
+    if(FTYPE.eq.3) aer_fra_file = trim(datadir)//'/optical_tables/table_sigma_int2_fr2.30_rm50nm.dat'
+    if(FTYPE.eq.4) aer_fra_file = trim(datadir)//'/optical_tables/table_sigma_int2_fr2.45_rm50nm.dat'
+    inquire(file=trim(aer_fra_file),exist=file_ok)
+    if(.not.file_ok) then
+      write(*,*) 'The file ',TRIM(aer_fra_file),' was not found by get_haze_and_cloud_opacity.F90 !'
+      write(*,*) 'Check in ', TRIM(datadir),' that you have the one corresponding !!'
+      call abort
+    endif
+    open(unit = 26, file = aer_fra_file)
+    
+    ! And clouds :
+    cloud_file = trim(datadir)//'/optical_tables/table_sigma_int2_sphere.dat'
+    inquire(file=trim(cloud_file),exist=file_ok)
+    if(.not.file_ok) then
+      write(*,*) 'The file ',TRIM(cloud_file),' was not found by get_haze_and_cloud_opacity.F90 !'
+      write(*,*) 'Check in ', TRIM(datadir),' that you have the one corresponding !!'
+      call abort
+    endif
+    open(unit = 25, file = cloud_file)
+
+    do ii = 1, nwl    ! 46 loops on wlnv
+      do kk = 1, nrad ! 33 loops on rc 
+
+        read(25,*) iii, kkk, xwlnv(ii), rc_s(kk), &
+                   ssca_s(ii,kk), sabs_s(ii,kk), sext_s(ii,kk), &
+                   gbar_s(ii,kk), wbar_s(ii,kk)
+        if(ii.ne.iii .or. kk.ne.kkk) then
+          write(*,*) 'lecture unit = 25'
+          write(*,*) 'ii, iii : ', ii, iii
+          write(*,*) 'kk, kkk : ', kk, kkk
+          stop
+        endif
+
+        read(26,*) iii, kkk, xwlnv(ii), rc_f(kk), &
+                   ssca_f(ii,kk), sabs_f(ii,kk), sext_f(ii,kk), &
+                   gbar_f(ii,kk), wbar_f(ii,kk)
+        if(ii.ne.iii .or. kk.ne.kkk) then
+          write(*,*) 'lecture unit = 26'
+          write(*,*) 'ii, iii : ', ii, iii
+          write(*,*) 'kk, kkk : ', kk, kkk
+          stop
+        endif
+
+        read(27,*) iii, kkk, xwlnv(ii), rc_as(kk), &
+                   ssca_as(ii,kk), sabs_as(ii,kk), sext_as(ii,kk), &
+                   gbar_as(ii,kk), wbar_as(ii,kk)
+        if(ii.ne.iii .or. kk.ne.kkk) then
+          write(*,*) 'lecture unit = 27'
+          write(*,*) 'ii, iii : ', ii, iii
+          write(*,*) 'kk, kkk : ', kk, kkk
+          stop
+       endif
+
+      enddo ! End loop on kk
+    enddo   ! End loop on ii
+
+    if(firstcall) firstcall = .false.
+
+    close(25)
+    close(26)
+    close(27)
+  endif ! End firstcall
+
+
+  !-------------------------
+  ! 2. Interpolate
+  !-------------------------
+
+  rinit = 1.e-9                ! fin = rinit*step**(33-1) = 1.e-5
+  if(CTYPE.eq.0) rinit = 1.e-7 ! fin = rinit*step**(33-1) = 1.e-3
+
+  ! No alpha(k) !
+  ! Because it is taken into account in the optical tables ...
+  rc = (m3/m0)**(1./3.)
+  
+  step = 10.**(1./8.)
+  idx = int(log(rc/rinit) / log(step)) + 1
+
+  ! Spherical (cloud) :
+  !--------------------
+  IF(CTYPE.EQ.0) THEN
+
+    if(abs(rc_s(1)-rinit)/rc_s(1).gt.1.e-5 .or. &
+       abs(rc_s(nrad)-rinit*step**32)/rc_s(nrad).gt.1.e-5) then
+        write(*,*) 'rinit          = ',rinit
+        write(*,*) 'rc_s(1)        = ',rc_s(1)
+        write(*,*) 'rinit*step**32 = ',rinit*step**32
+        write(*,*) 'rc_s(nrad)     = ',rc_s(nrad)
+        stop
+    endif
+
+    if(rc.le.rc_s(1)) then
+      wbar   = wbar_s(ich,1)
+      gbar   = gbar_s(ich,1)
+      tauext = sext_s(ich,1)*(rc/rc_s(1))**3
+    endif
+
+    if(rc.ge.rc_s(nrad)) then
+      wbar   = wbar_s(ich,nrad)
+      gbar   = gbar_s(ich,nrad)
+      tauext = sext_s(ich,nrad)*(rc/rc_s(nrad))**3.
+    endif
+
+    if(rc.gt.rc_s(1) .and. rc.lt.rc_s(nrad)) then
+      xfact  = (log(rc)-log(rc_s(idx))) / (log(rc_s(idx+1))-log(rc_s(idx)))
+      tauext = log(sext_s(ich,idx))*(1.-xfact) + log(sext_s(ich,idx+1))*xfact 
+      tauext = exp(tauext)
+      wbar   = wbar_s(ich,idx)*(1.-xfact) + wbar_s(ich,idx+1)*xfact 
+      gbar   = gbar_s(ich,idx)*(1.-xfact) + gbar_s(ich,idx+1)*xfact 
+    endif
+
+  ENDIF ! (CTYPE.EQ.0)
+
+  ! Spherical (haze) :
+  !-------------------
+  IF(CTYPE.EQ.5) THEN
+
+    if(abs(rc_as(1)-rinit)/rc_as(1).gt.1.e-5 .or. &
+       abs(rc_as(nrad)-rinit*step**32)/rc_as(nrad).gt.1.e-5) then
+        write(*,*) 'rinit          = ',rinit
+        write(*,*) 'rc_as(1)       = ',rc_as(1)
+        write(*,*) 'rinit*step**32 = ',rinit*step**32
+        write(*,*) 'rc_as(nrad)    = ',rc_as(nrad)
+        stop
+    endif
+
+    if(rc.le.rc_as(1)) then
+      wbar   = wbar_as(ich,1)
+      gbar   = gbar_as(ich,1)
+      tauext = sext_as(ich,1)*(rc/rc_as(1))**3
+    endif
+
+    if(rc.ge.rc_as(nrad)) then
+      wbar   = wbar_as(ich,nrad)
+      gbar   = gbar_as(ich,nrad)
+      tauext = sext_as(ich,nrad)*(rc/rc_as(nrad))**3.
+    endif
+
+    if(rc.gt.rc_as(1) .and. rc.lt.rc_as(nrad)) then
+      xfact  = (log(rc)-log(rc_as(idx))) / (log(rc_as(idx+1))-log(rc_as(idx)))
+      tauext = log(sext_as(ich,idx))*(1.-xfact) + log(sext_as(ich,idx+1))*xfact
+      tauext = exp(tauext)
+      wbar   = wbar_as(ich,idx)*(1.-xfact) + wbar_as(ich,idx+1)*xfact
+      gbar   = gbar_as(ich,idx)*(1.-xfact) + gbar_as(ich,idx+1)*xfact
+    endif
+  
+  ENDIF ! (CTYPE.EQ.5)
+
+  ! Fractal (haze) :
+  !-----------------
+  IF(CTYPE.NE.0 .AND. CTYPE.NE.5) THEN
+
+    if(abs(rc_f(1)-rinit)/rc_f(1).gt.1.e-5 .or. &
+       abs(rc_f(nrad)-rinit*step**32)/rc_f(nrad).gt.1.e-5) then
+        write(*,*) 'rinit          = ',rinit
+        write(*,*) 'rc_f(1)        = ',rc_f(1)
+        write(*,*) 'rinit*step**32 = ',rinit*step**32
+        write(*,*) 'rc_f(nrad)     = ',rc_f(nrad)
+        stop
+    endif
+
+    if(rc.le.rc_f(1)) then
+      wbar   =  wbar_f(ich,1)
+      gbar   =  gbar_f(ich,1)
+      tauext = sext_f(ich,1)*(rc/rc_f(1))**3
+    endif
+
+    if(rc.ge.rc_f(nrad)) then
+      wbar   = wbar_f(ich,nrad)
+      gbar   = gbar_f(ich,nrad)
+      tauext = sext_f(ich,nrad)*(rc/rc_f(nrad))**3.
+    endif
+    
+    if(rc.gt.rc_f(1) .and. rc.lt.rc_f(nrad)) then
+      xfact  = (log(rc)-log(rc_f(idx))) / (log(rc_f(idx+1))-log(rc_f(idx)))
+      tauext = log(sext_f(ich,idx))*(1.-xfact) + log(sext_f(ich,idx+1))*xfact 
+      tauext = exp(tauext)
+      wbar   = wbar_f(ich,idx)*(1.-xfact) + wbar_f(ich,idx+1)*xfact 
+      gbar   = gbar_f(ich,idx)*(1.-xfact) + gbar_f(ich,idx+1)*xfact 
+    endif
+
+  ENDIF ! (CTYPE.NE.0 .AND. CTYPE.NE.5)
+
+  ! Sanity check :
+  !---------------
+  IF (CTYPE.LT.0 .AND. CTYPE.GT.5) THEN
+    write(*,*) 'CTYPE < 0 ET > 5  = ',CTYPE
+    call abort
+  ENDIF
+
+  tauext = tauext * m0
+
+  return
+
+end subroutine get_haze_and_cloud_opacity
Index: trunk/LMDZ.TITAN/libf/phytitan/inifis_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/inifis_mod.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/inifis_mod.F90	(revision 3083)
@@ -194,4 +194,44 @@
      call getin_p("eff_gz", eff_gz)
      write(*,*) "eff_gz = ", eff_gz
+
+     write(*,*) "Nudging of zonal wind to keep the super-rotation"
+     nudging_u = .true.
+     call getin_p("nudging_u", nudging_u)
+     write(*,*) "nudging_u = ", nudging_u
+
+     write(*,*) "Nudging relaxation time (here ~ 1 titanian year in secondes)"
+     nudging_dt = 9.3e8
+     call getin_p("nudging_dt", nudging_dt)
+     write(*,*) "nudging_dt = ", nudging_dt
+
+     write(*,*) "New optics for clouds"
+     opt4clouds = .true.
+     call getin_p("opt4clouds", opt4clouds)
+     write(*,*) "opt4clouds = ", opt4clouds
+
+     write(*,*) "Cloudy fraction in the Clear / Dark column method"
+     Fcloudy = 1.0
+     call getin_p("Fcloudy", Fcloudy)
+     write(*,*) "Fcloudy = ", Fcloudy
+
+     write(*,*) "Adjustment of single scattering albedo for cloudy dropplet"
+     Fssa = 1.0
+     call getin_p("Fssa", Fssa)
+     write(*,*) "Fssa = ", Fssa
+     
+     write(*,*) "Adjustment of aerosol properties in the VIS"
+     FHVIS = 1.0
+     call getin_p("FHVIS", FHVIS)
+     write(*,*) "FHVIS = ", FHVIS
+
+     write(*,*) "Adjustment of aerosol properties in the IR"
+     FHIR = 1.0
+     call getin_p("FHIR", FHIR)
+     write(*,*) "FHIR = ", FHIR
+
+     write(*,*) "Infinite tank of CH4 ?"
+     resCH4_inf = .false.
+     call getin_p("resCH4_inf", resCH4_inf)
+     write(*,*) "resCH4_inf = ", resCH4_inf
      
      ! sanity check warning
Index: trunk/LMDZ.TITAN/libf/phytitan/inimufi.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/inimufi.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/inimufi.F90	(revision 3083)
@@ -23,4 +23,5 @@
   !     -------
   !     J. Vatant d'Ollone, J.Burgalat, S.Lebonnois (09/2017)
+  !     B. de Batz de Trenquelléon (02/2023)
   !
   !============================================================================
@@ -73,6 +74,11 @@
        ENDIF
      ENDDO
+     
+     nice = mm_nesp
+
      ALLOCATE(ices_indx(mm_nesp))
+     ALLOCATE(gazs_indx(mm_nesp))
      ices_indx(:) = -1
+     gazs_indx(:) = -1
      DO i=1,mm_nesp 
        idx = indexOfTracer("mu_m3"//TRIM(mm_spcname(i)),.false.)
@@ -83,11 +89,27 @@
          ices_indx(i) = idx
        ENDIF
+
+       idx = indexOfTracer(TRIM(mm_spcname(i)),.false.)
+       IF (idx <= 0) THEN
+         WRITE(*,*) "inimufi: '"//TRIM(mm_spcname(i))//"' not found in tracers table."
+         err = .true.
+       ELSE
+         gazs_indx(i) = idx
+       ENDIF
      ENDDO
+
      IF (err) THEN
        WRITE(*,*) "You loose.... Try again"
        STOP
      ENDIF
+     
+     write(*,*) 'DUMPTRACERS - MICRO_INDX'
+     call dumpTracers(micro_indx)
+     write(*,*) 'DUMPTRACERS - ICES_INDX'
+     call dumpTracers(ices_indx)
+     write(*,*) 'DUMPTRACERS - GAZS_INDX'
+     call dumpTracers(gazs_indx)
    ENDIF
-
+   
 #endif
 
Index: trunk/LMDZ.TITAN/libf/phytitan/muphy_diag.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/muphy_diag.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/muphy_diag.F90	(revision 3083)
@@ -14,4 +14,7 @@
   REAL(kind=8), ALLOCATABLE, DIMENSION(:)     :: mmd_aer_prec   !! Aerosols precipitations (both modes) (m).
   REAL(kind=8), ALLOCATABLE, DIMENSION(:)     :: mmd_ccn_prec   !! CCN precipitations (m).
+  REAL(kind=8), ALLOCATABLE, DIMENSION(:,:)   :: mmd_aer_s_w    !! Spherical aerosol settling velocity (\(m.s^{-1}\)).
+  REAL(kind=8), ALLOCATABLE, DIMENSION(:,:)   :: mmd_aer_f_w    !! Fractal aerosol settling velocity (\(m.s^{-1}\)).
+  REAL(kind=8), ALLOCATABLE, DIMENSION(:,:)   :: mmd_ccn_w      !! CCN settling velocity (\(m.s^{-1}\)).
   REAL(kind=8), ALLOCATABLE, DIMENSION(:,:)   :: mmd_aer_s_flux !! Spherical aerosol mass flux (\(kg.m^{-2}.s^{-1}\)).
   REAL(kind=8), ALLOCATABLE, DIMENSION(:,:)   :: mmd_aer_f_flux !! Fractal aerosol mass flux (\(kg.m^{-2}.s^{-1}\)).
@@ -24,5 +27,5 @@
   REAL(kind=8), ALLOCATABLE, DIMENSION(:,:)   :: mmd_rc_cld     !! Cloud drop radius (m).
 
-  !$OMP THREADPRIVATE(mmd_aer_prec,mmd_ccn_prec,mmd_aer_s_flux,mmd_aer_f_flux,mmd_ccn_flux,mmd_ice_fluxes)
+  !$OMP THREADPRIVATE(mmd_aer_prec,mmd_ccn_prec,mmd_aer_s_w,mmd_aer_f_w,mmd_ccn_w,mmd_aer_s_flux,mmd_aer_f_flux,mmd_ccn_flux,mmd_ice_fluxes)
   !$OMP THREADPRIVATE(mmd_gazs_sat,mmd_ice_prec,mmd_rc_sph,mmd_rc_fra,mmd_rc_cld)
 
@@ -36,4 +39,7 @@
     ALLOCATE(mmd_aer_prec(ngrid))
     ALLOCATE(mmd_ccn_prec(ngrid))
+    ALLOCATE(mmd_aer_s_w(ngrid,nlayer))
+    ALLOCATE(mmd_aer_f_w(ngrid,nlayer))
+    ALLOCATE(mmd_ccn_w(ngrid,nlayer))
     ALLOCATE(mmd_aer_s_flux(ngrid,nlayer))
     ALLOCATE(mmd_aer_f_flux(ngrid,nlayer))
@@ -48,4 +54,7 @@
     mmd_aer_prec(:)       = 0d0
     mmd_ccn_prec(:)       = 0d0
+    mmd_aer_s_w(:,:)      = 0d0
+    mmd_aer_f_w(:,:)      = 0d0
+    mmd_ccn_w(:,:)        = 0d0
     mmd_aer_s_flux(:,:)   = 0d0
     mmd_aer_f_flux(:,:)   = 0d0
@@ -64,4 +73,7 @@
     IF (ALLOCATED(mmd_aer_prec))   DEALLOCATE(mmd_aer_prec)
     IF (ALLOCATED(mmd_ccn_prec))   DEALLOCATE(mmd_ccn_prec)
+    IF (ALLOCATED(mmd_aer_s_w))    DEALLOCATE(mmd_aer_s_w)
+    IF (ALLOCATED(mmd_aer_f_w))    DEALLOCATE(mmd_aer_f_w)
+    IF (ALLOCATED(mmd_ccn_w))      DEALLOCATE(mmd_ccn_w)
     IF (ALLOCATED(mmd_aer_s_flux)) DEALLOCATE(mmd_aer_s_flux)
     IF (ALLOCATED(mmd_aer_f_flux)) DEALLOCATE(mmd_aer_f_flux)
